// mecab_wrap.cpp : DLL AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "mecab_wrap.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

MECAB_WRAP_API mecab_t* __stdcall mecab_new2_wrap(const char *arg)
{
	return (mecab_t *)mecab_new2(arg);
}

MECAB_WRAP_API void __stdcall mecab_destroy_wrap(mecab_t *m)
{
	mecab_destroy((mecab_t *)m);
}

MECAB_WRAP_API void __stdcall mecab_sparse_tostr_wrap(mecab_t *m, const char *str, char *ret, int sz)
{
	strncpy(ret, mecab_sparse_tostr((mecab_t *)m, str), sz - 1);
	ret[sz - 1] = '\0';
}

MECAB_WRAP_API void __stdcall mecab_version_wrap(char *ver, int sz)
{
	strncpy(ver, mecab_version(), sz - 1);
	ver[sz - 1] = '\0';
}
